program inverse_with_lapack
  implicit none
  integer, parameter :: size= 10
  
  real, dimension(:,:), allocatable :: A,A1, A1A 
  integer :: n, i,j,l
  
  allocate( A(size, size), A1(size, size), A1A(size, size)  )
  
  n = size
  
  ! assembling of the matrix
  A(:,:) = 0.
  do i=1, n
     A(i,i) = 2. + 2.*i/n
     if(i < n) A(i,i+1) = -1. + 1./n
  enddo
  !A(n, 1) = -1.
  
  ! copy of the original matrix
  A1(1:n, 1:n) = A(1:n, 1:n)
  
  ! calling the computation of inverse matrix, input is overwritten
  call MblockInverse(n, A1)
  
  
   print*,'matrix A'
  do i=1,n
     write(*,'(i5, 300es12.4)') i, A(i, :)
  enddo
  print*,'------------------------------------'

   print*,'inversion of matrix A'
  do i=1,n
     write(*,'(i5, 300es12.4)') i, A1(i, :)
  enddo
  print*,'------------------------------------'

  ! verification of the inversion of the matrix
  A1A = matmul(A(1:n, 1:n), A1(1:n, 1:n) )

  print*,'verification of 1 * A^{-1}'
  do i=1,n
     write(*,'(i5, 300es12.4)') i, A1A(i, :)
  enddo


  
end program inverse_with_lapack
