  !> evaluation of the inverse (\f$ A^{-1} \f$ ) to \f$ A\in R^{n\times n} \f$
  subroutine  MblockInverse(n, A)
    integer, intent(in) :: n
    real, dimension(1:n,1:n), intent(inout) :: A
    external:: dgetri, dgetrf          ! subroutines from LAPACK
    integer, dimension(:), allocatable :: ident
    real, dimension(:), allocatable :: work
    integer :: info, iwork

    !do i=1,n
    !   write(*,'(i5,100es12.4)') i, A(i,:)
    !enddo
    !write(*,*)

    !iwork = 100 * 30
    iwork = 2*n
    allocate(ident(1:n), work(1:iwork) )
    ident(:) = 1

    !print*,'@@@', state%space%max_dof

    call DGETRF(n, n, A, n, ident, info )
    if(info /= 0 ) print*,'Problem 1 in MblockInverse in matrix.f90 ', info
    if(info /= 0 ) stop

    call DGETRI(n, A, n, ident, work,  iwork, info )
    if(info /= 0 ) print*,'Problem 2 in MblockInverse in matrix.f90 ', info
    if(info /= 0 ) stop

    deallocate(ident, work)

  end subroutine MblockInverse
